/* Autor: Sergio Blanco Cuaresma
 * Data: Agost 2002
 * Descripci: Organitzador d'un catleg musical en el qual es poden crear categories
 * amb subcategories i albums. Els albums no es podran afegir a l'arrel que sera
 * denominada "musica".
 */

public class org {
  private NodeArbre arrel;
  private Hashing categories;
  private Hashing albums;

  // Inicialitza el node Arrel, el qual no tindr germans i es dira "musica"
  org(int max_cat, int max_albums) throws ElemRepetit {
    categories = new Hashing((int)(max_cat/0.7));
    albums = new Hashing((int)(max_albums/0.7));
    arrel = new NodeArbre(new Categoria("musica"), true);
    categories.afegir("musica", arrel, false);
  }

  public void imprimir(){
    System.out.println("Organitzador");
  }
  
  // Afegeix una categoria al Arbre i a la taula de Hashing de categories
  public void afegir_categoria (String c2, String c1) throws NoExisteix, ElemRepetit {
    NodeArbre tmp, n;
    
    n = new NodeArbre(new Categoria(c2), true);
    
      // Buscar a la taula de Hash una entrada que ens porti al NodeArbre amb nom c1
      tmp = (NodeArbre)categories.consultar(c1);
      if (tmp.fill() != null) {   // Busquem un lloc per afegir
        tmp = tmp.fill();
        while (tmp.germa()!=null) {
          tmp = tmp.germa();
        }
        tmp.germa(n);   // Afegim
      } else {
        tmp.fill(n);    // Afegim
      }
    // Afegir Hash
    categories.afegir(c2, n, false);  // Sense repetits
  }

  // Afegeix un album al Arbre i a la taula de Hashing d'albums
  public void afegir_album (String c1, Album a) throws NoArrel, NoExisteix, ElemRepetit{
    NodeArbre tmp, n, c;

    n = new NodeArbre(a, false);

    if (c1.equals("musica")) {  // No deixem ficar albums a l'arrel
      throw new NoArrel();
    } else {
      // Buscar a la taula de Hash una entrada que ens porti al NodeArbre amb nom c1
      c = (NodeArbre)categories.consultar(c1);
      tmp = c;
      if (tmp.fill() != null) {   // Busquem un lloc per afegir
        tmp = tmp.fill();
        while (tmp.germa()!=null) {
          tmp = tmp.germa();
        }
        tmp.germa(n);   // Afegim
      } else {
        tmp.fill(n);    // Afegim
      }
    }
    // Afegir Hash
    albums.afegir(a.consultar_titol(), c);
  }

  // Crida recursiva que ens ajudara a construir una Llista amb tots els albums
  // que hi han a partir d'una categoria donada
  private void construirLlista(Llista l, NodeArbre n) throws NoMemoria{
    NodeArbre tmp;

    tmp=n.fill();
    while (tmp!=null){
      if (tmp.categoria()) {
        construirLlista(l, tmp);
      } else {
        l.insertar(tmp.info());
      }
      tmp = tmp.germa();
    }
  }

  // Construeix llista d'albums dintre de una categoria donada i les seves subcategories
  public Llista albums_categoria (String s) throws NoMemoria, NoExisteix{
    NodeArbre tmp;
    Llista llistat=new Llista();

    tmp = (NodeArbre)categories.consultar(s);
    construirLlista(llistat, tmp);
    return llistat;
  }

  // Construeix una llista d'strings amb les subcategories del seguent nivell d'una categoria
  public Llista subcategories (String s) throws NoMemoria, NoExisteix{
    NodeArbre tmp;
    Llista llistat=new Llista();

      // Buscar Hash
      tmp = (NodeArbre)categories.consultar(s);   // Ens situem
      tmp = tmp.fill();
      while (tmp != null){  // Fem la busqueda de categories
        if (tmp.categoria()) {
          llistat.insertar(((Categoria)(tmp.info())).nom());
        }
        tmp = tmp.germa();
      }
      return llistat;
  }

  // Construeix una llista d'strings amb les categories a les que pertany un album
  public Llista categories (String s) throws NoMemoria, NoExisteix{
    NodeHash tmp;
    Llista llistat=new Llista();

    // Buscar Hash
    tmp = (NodeHash)albums.consultar(s, true);  // Ens situem (ens retornara un NodeHash,
                                                // d'aquesta forma podrem tractar tots els sinonims
                                                // amb noms repetits des d'aqui)
    while (tmp!=null){
      if ((tmp.nom()).equals(s)) {
        llistat.insertar(((Categoria)( ((NodeArbre)(tmp.info())).info() )).nom());
      }
      tmp = tmp.sinonim();
    }
    return llistat;

  }

}
